﻿
local valkyrName = "Val'kyr Shadowguard"

-- main view
local mainFrame = CreateFrame("Frame", "ValkyrDetector:mainFrame", UIparent)
mainFrame:SetPoint("TOP")
mainFrame:SetFrameStrata("BACKGROUND")
mainFrame:SetMovable(true)
mainFrame:EnableMouse(true)
mainFrame:RegisterForDrag("RightButton")
mainFrame:RegisterForDrag("LeftButton")
mainFrame:SetScript("OnDragStart", mainFrame.StartMoving)
mainFrame:SetScript("OnDragStop", mainFrame.StopMovingOrSizing)
mainFrame:SetWidth(150)
mainFrame:SetHeight(90)
local mainFrameTexture = mainFrame:CreateTexture("Texture")
mainFrameTexture:SetAllPoints()
mainFrameTexture:SetTexture(0, 0, 0, 0)
local mainFrameIsHidden = false

-- valkyr view
local valkyrFrames = {}
function CreateValkyrFrame(id, point, r, g, b)
	-- view
	valkyrFrames[id] = CreateFrame("Frame", "ValkyrDetector:valkyrFrame"..id, mainFrame)
	valkyrFrames[id]:SetPoint(point)
	valkyrFrames[id]:SetWidth(150)
	valkyrFrames[id]:SetHeight(30)
	local tmpTexture = valkyrFrames[id]:CreateTexture("ValkyrDetector:valkyrFrameTexture"..id)
	tmpTexture:SetAllPoints()
	tmpTexture:SetTexture(r/255, g/255, b/255, 1)
	-- data
	local tmpFontString = valkyrFrames[id]:CreateFontString("ValkyrDetector:valkyrFrameFontString"..id)
	tmpFontString:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	tmpFontString:SetPoint("RIGHT", 0, 0)
	tmpFontString:SetText("")
	-- references
	valkyrFrames[id].FontString = tmpFontString
end
CreateValkyrFrame(0, "TOPLEFT", 229, 132, 3)
CreateValkyrFrame(1, "LEFT", 139, 14, 112)
CreateValkyrFrame(2, "BOTTOMLEFT", 9, 230, 3)

-- phase de test de l'interface
valkyrFrames[0].FontString:SetText("Phase de test de l'addon : ValkyrDetector                             ")
valkyrFrames[1].FontString:SetText("Déplacer moi en maintenant clique gauche ou droit !                             ")
valkyrFrames[2].FontString:SetText("Cliquer une fois pour me faire disparaitre !                             ")
mainFrame:SetScript("OnMouseUp", function()
	mainFrameIsHidden = true
	mainFrame:Hide()
	valkyrFrames[0].FontString:SetText("")
	valkyrFrames[1].FontString:SetText("")
	valkyrFrames[2].FontString:SetText("")
	mainFrame:SetMovable(false)
	mainFrame:EnableMouse(false)
	mainFrame:SetScript("OnDragStart", nil)
	mainFrame:SetScript("OnDragStop", nil)
end)


-- detection valkyr
local isValkyrPhase = false
local frameDetectionValkyr = CreateFrame("Frame", "ValkyrDetector:frameDetectionValkyr")
frameDetectionValkyr:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frameDetectionValkyr:SetScript("OnEvent", function(self, event, a, b, c, src, e, f, dest)
	if(not isValkyrPhase) then
		if(not isValkyrPhase and src and dest and (strfind(dest, valkyrName) or strfind(src, valkyrName))) then
			isValkyrPhase = true
		end
	end
end)


-- check if unit can dodge valkyr
local UnitDodgeType = function(unit)
	if(select(2, UnitClass(unit))=="WARLOCK") then
		return ""
	end
	if(select(2, UnitClass(unit))=="HUNTER") then
		return "(chute lente)"
	end
	if(select(2, UnitClass(unit))=="MAGE") then
		return ""
	end
	if(select(2, UnitClass(unit))=="WARRIOR") then
		return "(interv)"
	end
	return UnitName(unit)
end

-- update valkyr view
local updated = true
local indexIcon = 2
local tabPlayerGrab = {}
local updateMainFrame = CreateFrame("Frame", "ValkyrDetector:updateMainFrame")
updateMainFrame:SetScript("OnUpdate",
	function (self, elapsed)
		if(updated and isValkyrPhase) then
			updated = false
			
			local isSomeoneGrabbed = false
			
			for i = 1, 40 do
				if(UnitInVehicle("raid"..i)) then
				
					if(not mainFrame:IsVisible()) then
						mainFrame:Show()
					end
				
					isSomeoneGrabbed = true
					
					if(tabPlayerGrab[2]~=i and tabPlayerGrab[3]~=i and tabPlayerGrab[4]~=i) then
						
						if(indexIcon==2) then
							valkyrFrames[0].FontString:SetText(UnitDodgeType("raid"..i))
							tabPlayerGrab[2] = i
							indexIcon = indexIcon+1
						elseif(indexIcon==3) then
							valkyrFrames[1].FontString:SetText(UnitDodgeType("raid"..i))
							tabPlayerGrab[3] = i
							indexIcon = indexIcon+1
						elseif(indexIcon==4) then
							valkyrFrames[2].FontString:SetText(UnitDodgeType("raid"..i))
							tabPlayerGrab[4] = i
							indexIcon = indexIcon+1
						end
						
					end
				end
			end
			
			if(not isSomeoneGrabbed and mainFrame:IsVisible()) then
				mainFrame:Hide()
				valkyrFrames[0].FontString:SetText("")
				valkyrFrames[1].FontString:SetText("")
				valkyrFrames[2].FontString:SetText("")
				indexIcon = 2
				tabPlayerGrab = {}
			end
			
			updated = true
		end
	end
)
